<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Shops for Rent</title>
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet">
    <style>
        body {
            background-color: #eaf6ff;
        }
        .shop-card {
            transition: transform 0.3s ease, box-shadow 0.3s ease;
        }
        .shop-card:hover {
            transform: translateY(-5px);
            box-shadow: 0 10px 20px rgba(0, 0, 0, 0.2);
        }
        .shop-image {
            height: 200px;
            object-fit: cover;
        }
    </style>
</head>
<body>
    <div class="container py-5">
        <h2 class="text-center mb-4">Available Shops</h2>
        <div class="row">
            <?php
            // Example PHP array to simulate data from a database
            $shops = [
                ['id' => 1, 'name' => 'Prime Shop', 'location' => 'Downtown', 'price' => '₦200,000/month', 'description' => 'Spacious shop in a prime location. Perfect for any business.', 'image' => 'https://via.placeholder.com/300x200'],
                ['id' => 2, 'name' => 'Cozy Corner', 'location' => 'Suburb', 'price' => '₦100,000/month', 'description' => 'Affordable shop with great foot traffic.', 'image' => 'https://via.placeholder.com/300x200'],
                ['id' => 3, 'name' => 'Elite Plaza', 'location' => 'City Center', 'price' => '₦300,000/month', 'description' => 'High-end shop space for premium businesses.', 'image' => 'https://via.placeholder.com/300x200'],
            ];

            foreach ($shops as $shop) {
                echo "
                <div class='col-md-4 mb-4'>
                    <div class='card shop-card'>
                        <img src='{$shop['image']}' class='card-img-top shop-image' alt='Image of {$shop['name']}'>
                        <div class='card-body'>
                            <h5 class='card-title'>{$shop['name']}</h5>
                            <h6 class='card-subtitle mb-2 text-muted'>{$shop['location']}</h6>
                            <p class='card-text'>{$shop['description']}</p>
                            <p class='fw-bold'>Price: {$shop['price']}</p>
                            <a href='shop-details.php?id={$shop['id']}' class='btn btn-primary'>View Details</a>
                        </div>
                    </div>
                </div>
                ";
            }
            ?>
        </div>
    </div>
</body>
</html>
