<?php
ob_start();
require_once('login.php');
session_start();
$log = new Login();

$statement =  $log->getShops();

$isLoggedIn = isset($_SESSION['user']);


?>
<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Shops for Rent</title>
    <!-- Bootstrap CSS -->
    <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/css/bootstrap.min.css" rel="stylesheet">
    <style>
        body {
            background-color: #eaf6ff;
        }
        nav {
            background-color: #007bff;
        }
        nav a.nav-link {
            color: #fff;
            transition: color 0.3s ease;
        }
        nav a.nav-link:hover {
            color: #ffeb3b;
        }
        header {
            background: linear-gradient(90deg, #007bff, #0056b3);
            color: white;
            padding: 50px 0;
            text-align: center;
        }
        header h1 {
            font-size: 2.5rem;
            margin-bottom: 10px;
        }
        header p {
            font-size: 1.2rem;
        }
        .shop-card {
            transition: transform 0.3s ease, box-shadow 0.3s ease;
            background: #fff;
            border: none;
            border-radius: 10px;
            overflow: hidden;
        }
        .shop-card:hover {
            transform: translateY(-5px);
            box-shadow: 0 10px 20px rgba(0, 0, 0, 0.2);
        }
        .shop-image {
            height: 200px;
            object-fit: cover;
        }
        .btn-primary {
            background-color: #007bff;
            border: none;
        }
        .btn-primary:hover {
            background-color: #0056b3;
        }
    </style>
</head>
<body>
    <!-- Navigation -->
    <nav class="navbar navbar-expand-lg navbar-dark sticky-top">
        <div class="container">
            <a class="navbar-brand" href="#">ShopsForRent</a>
            <button class="navbar-toggler" type="button" data-bs-toggle="collapse" data-bs-target="#navbarNav" aria-controls="navbarNav" aria-expanded="false" aria-label="Toggle navigation">
                <span class="navbar-toggler-icon"></span>
            </button>
            <div class="collapse navbar-collapse" id="navbarNav">
                <ul class="navbar-nav ms-auto">
                    <li class="nav-item">
                        <a class="nav-link" href="#">Home</a>
                    </li>
                    <li class="nav-item">
                        <a class="nav-link" href="#shops">Shops</a>
                    </li>
                   
                    <li class="nav-item">
                        <a class="nav-link" href="register.php">Register</a>
                    </li>
                <?php   
                    if ($isLoggedIn) {

                        ?>

<li class="nav-item">
                        <a class="nav-link" href="backend/login.php">Log out</a>
                    </li>
                     <?php



                    }
                    

               else {  
               ?>
                    <li class="nav-item">
                        <a class="nav-link" href="backend/login.php">Login</a>
                    </li>

                <?php   } ?>    

                    <li class="nav-item">
                        <a class="nav-link" href="#">Contact</a>
                    </li>
                </ul>
            </div>
        </div>
    </nav>

    <!-- Header -->
    <header>
        <div class="container">
            <h1>Find Your Ideal Shop</h1>
            <p>Browse through the best locations and deals available for rent</p>
        </div>
    </header>

    <!-- Shops Section -->
    <div class="container py-5" id="shops">
        <h2 class="text-center mb-4">Available Shops</h2>
        <div class="row">
            <?php
           

            // Loop through shops and display them in cards
            while ($row = $statement->fetch(PDO::FETCH_ASSOC)){
                extract($row);
                echo "
                <div class='col-md-4 mb-4'>
                    <div class='card shop-card'>
                        <img src='backend/{$row['image']}' class='card-img-top shop-image' alt='Image of {$row['shop_number']}'>
                        <div class='card-body'>
                          <p class='fw-bold'>Shop Number: {$row['shop_number']}</p>
                            <p class='fw-bold'>Location: {$row['name']}</p>
                              <p class='fw-bold'>Price: ₦{$row['price']}</p>
                            <h6 class='card-subtitle mb-2 text-muted'>Size: {$row['size']}</h6>
                            <p class='card-text'>Features: {$row['features']}</p>

                            
                          
                            <a href=' shopDetails.php?id={$row['shop_id'] } ' class='btn btn-primary'>View Details</a>


                
               

                        </div>
                    </div>
                </div>
                ";
            }
            ?>
        </div>
    </div>

    <!-- Bootstrap Bundle with Popper -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.0-alpha3/dist/js/bootstrap.bundle.min.js"></script>
</body>
</html>
