<?php
require_once( "db.php" );
//require_once( "useSingleton.php" );
/**
 * Methods for database handling.
 */
class Login extends Db  {

   
    const BCRYPT_COST = 14;
	
	public $email;
	public $password;
	public $role;
	public $exist;
	 
	 
	 public function __construct() {

   }
	 
	 
    

    /**
     * Gets given users password.
     *
     * @param $email The username to get the password of.
     * @return The password of the given user.
     */
    public function getUsersPassword($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT password
                FROM   login
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];

       parent::DisConnect( $MySQLiconn);

        return $this->password;
    }

    /**
     * Creates a new user.
     *
     * @param $email The username to create.
     * @param $password The password of the user.
     */
    public function createLogin($email, $password,$role,$textcode) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
       $sql = "INSERT INTO login (email,password,role,textcode)
                VALUES (:email, :password, :role, :textcode)";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':email',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        $statement->bindValue(":role", $role,  PDO::PARAM_STR);

		$statement->bindValue(":textcode", $textcode , PDO::PARAM_STR);
			
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }
	
	
	
	
	public function countAll(){
	$instance = parent::getInstance();
		//$instance = new DBAccess();
       $MySQLiconn  = $instance->getConnection();	
 
   $sql = "SELECT * from members";
				$statement = $MySQLiconn->prepare($sql);
    $statement->execute();
 
    $num = $statement->rowCount();
 
    return $num;
	parent::DisConnect( $MySQLiconn);
}







public function getUsersPassword2($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   login
                WHERE  email = :email';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':email', $email);

        $statement->execute();
		$row = $statement->fetch(PDO::FETCH_ASSOC);
	
	   $this->role = $row['role'];
 
    return $this->role;
        
      
		 parent::DisConnect( $MySQLiconn);
		
    }

   public function getPassword(){
	   return $this->password ;
	   }
	   
	 public function getRole(){
	   return $this->role ;
	   }   
	
	
	
	 public function updateLoginDetails($email,$password,$password2) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
    //   $sql = "INSERT INTO login (staffno,password,role,email,textcode,password2)
              //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
			  
			  $sql = "UPDATE login SET password = :password, password2 = :password2 WHERE staffno = :staffno";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':staffno',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        
		
			$statement->bindValue(":password2", $password2 , PDO::PARAM_STR);
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }
	
	
	
	 public function updateSubjectLoginDetails($email,$password,$password2) {
	   $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();	
	   
	 try{
	 
    //   $sql = "INSERT INTO login (staffno,password,role,email,textcode,password2)
              //  VALUES (:staffno, :password, :role, :email, :textcode, :password2)";
			  
			  $sql = "UPDATE subjectlogin SET password = :password, password2 = :password2 WHERE staffno = :staffno";
					

       $options = array('cost' => self::BCRYPT_COST);
        $derivedPassword = password_hash($password, PASSWORD_BCRYPT, $options);
       // $derivedTexcode = md5(uniqid(rand())); 
        $statement = $MySQLiconn->prepare($sql);
	
        $statement->bindValue(':staffno',$email, PDO::PARAM_STR );
		
        $statement->bindValue(":password", $derivedPassword, PDO::PARAM_STR);
        
		
			$statement->bindValue(":password2", $password2 , PDO::PARAM_STR);
        $statement->execute();
		
		
		parent::DisConnect( $MySQLiconn);
	  }

        catch(Exception $e){
			echo "oops! ".$e->getMessage(); 
			
			}   
    }
	
	
		
      public function getUsersPasswordSubject($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT password
                FROM   subjectlogin
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();
        $row = $statement->fetch(PDO::FETCH_ASSOC);
        $this->password = $row['password'];

       parent::DisConnect( $MySQLiconn);

        return $this->password;
    }
 

  public function getUsersPassword2Subject($email) {
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   subjectlogin
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();
		$row = $statement->fetch(PDO::FETCH_ASSOC);
	
	   $this->role = $row['role'];
 
    return $this->role;
        
      
		 parent::DisConnect( $MySQLiconn);
		
    }



	
		
	
	
	
	public function checkStaffid($email){
	  
	  $instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'SELECT *
                FROM   login
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();
		//$row = $statement->fetch(PDO::FETCH_ASSOC);
		
     
	  $num = $statement->rowCount();
	 
 
    return $num;
        
      
		 parent::DisConnect( $MySQLiconn);
	  	
		
		} 	
		

  public function deleteStaffLogin($email){
		
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'DELETE 
                FROM   login
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();  
		  parent::DisConnect( $MySQLiconn);
		}		
	
	
	public function deleteStaffSubjectLogin($email){
		
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'DELETE 
                FROM   subjectlogin
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();  
		  parent::DisConnect( $MySQLiconn);
		}	
		
		
	
	public function deleteVerifySubjectLogin($email){
		
		$instance = parent::getInstance();	
       $MySQLiconn  = $instance->getConnection();
		
        $sql = 'DELETE 
                FROM   verifysubject
                WHERE  staffno = :staffno';

        $statement = $MySQLiconn->prepare($sql);
        $statement->bindValue(':staffno', $email);

        $statement->execute();  
		  parent::DisConnect( $MySQLiconn);
		}		


    // select user from 

    public function getAdmin($email) {
      $instance = parent::getInstance();	
         $MySQLiconn  = $instance->getConnection();
      
          $sql = 'SELECT *
                  FROM   admin
                  WHERE  email = :email';
  
          $statement = $MySQLiconn->prepare($sql);
          $statement->bindValue(':email', $email);
  
          $statement->execute();
      $row = $statement->fetch(PDO::FETCH_ASSOC);
    
       $this->fname = $row['fname'];

       $this->lname = $row['lname'];

       $this->phone = $row['phone'];
   
     
          
        
       parent::DisConnect( $MySQLiconn);
      
      }


    //select user


    // shop codes


    public function addLocation($name,$address,$num_shops,$area) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
        $sql = "INSERT INTO locations (name,address,num_shops,area)
                 VALUES (:name, :address, :num_shops, :area)";
           
 
       
         $statement = $MySQLiconn->prepare($sql);
   
         $statement->bindValue(':name',$name, PDO::PARAM_STR );
     
         $statement->bindValue(":address", $address, PDO::PARAM_STR);
         $statement->bindValue(":num_shops", $num_shops,  PDO::PARAM_STR);

         $statement->bindValue(":area", $area, PDO::PARAM_STR);
 
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }




     //update location



     public function updateLocation($location_id,$name,$address,$num_shops,$area) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
        $sql = " UPDATE locations set name = :name, address = :address, num_shops = :num_shops, area = :area
           where location_id = :location_id   ";
                         
           
 
       
         $statement = $MySQLiconn->prepare($sql);

         $statement->bindValue(':location_id',$location_id, PDO::PARAM_STR );
   
         $statement->bindValue(':name',$name, PDO::PARAM_STR );

         
     
         $statement->bindValue(":address", $address, PDO::PARAM_STR);
         $statement->bindValue(":num_shops", $num_shops,  PDO::PARAM_STR);

         $statement->bindValue(':area',$area, PDO::PARAM_STR );
 
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }



     // add shops


     public function addShop($location_id,$size,$price, $availability_status, $type, $features,$shop_number,$lease_duration) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
        $sql = "INSERT INTO shops (location_id,size,price,availability_status, type,features,shop_number,lease_duration)
                 VALUES (:location_id, :size, :price, :availability_status, :type, :features, :shop_number, :lease_duration)";
           
 
       
         $statement = $MySQLiconn->prepare($sql);
   
         $statement->bindValue(':location_id',$location_id, PDO::PARAM_STR );
     
         $statement->bindValue(":size", $size, PDO::PARAM_STR);
         $statement->bindValue(":price", $price,  PDO::PARAM_STR);

         $statement->bindValue(":availability_status", $availability_status,  PDO::PARAM_STR);

         $statement->bindValue(":type", $type,  PDO::PARAM_STR);

         $statement->bindValue(":features", $features,  PDO::PARAM_STR);

         $statement->bindValue(":shop_number", $shop_number,  PDO::PARAM_STR);

         $statement->bindValue(":lease_duration", $lease_duration,  PDO::PARAM_STR);
 
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }







     public function updateShop($shop_id,$location_id,$size,$price, $availability_status, $type, $features) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
        $sql = " 

          UPDATE  shops SET  location_id = :location_id, size = :size, price = :price, availability_status = :availability_status,
         type = :type,  features = :features where shop_id = :shop_id  ";
        
           
           
 
       
         $statement = $MySQLiconn->prepare($sql);
        
         $statement->bindValue(':shop_id',$shop_id, PDO::PARAM_STR );
          
         $statement->bindValue(':location_id',$location_id, PDO::PARAM_STR );
     
         $statement->bindValue(":size", $size, PDO::PARAM_STR);
         $statement->bindValue(":price", $price,  PDO::PARAM_STR);

         $statement->bindValue(":availability_status", $availability_status,  PDO::PARAM_STR);

         $statement->bindValue(":type", $type,  PDO::PARAM_STR);

         $statement->bindValue(":features", $features,  PDO::PARAM_STR);
 
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }





     public function addShopImages($images,$shop_id) {
      $instance = parent::getInstance();	
        $MySQLiconn  = $instance->getConnection();	
      
    try{
    
     $sql = "INSERT INTO shop_images (images, shop_id)
                VALUES (:images, :shop_id)";
           
 
       
         $statement = $MySQLiconn->prepare($sql);
   
         $statement->bindValue(':images',$images, PDO::PARAM_STR );
     
         $statement->bindValue(":shop_id", $shop_id, PDO::PARAM_STR);
        
 
         $statement->execute();
     
     
     parent::DisConnect( $MySQLiconn);
     }
 
         catch(Exception $e){
       echo "oops! ".$e->getMessage(); 
       
       }   
     }





     //add shops



    // shop codes

    // location count

    public function countLocation($name){
	  
      $instance = parent::getInstance();	
         $MySQLiconn  = $instance->getConnection();
      
          $sql = 'SELECT *
                  FROM   locations
                  WHERE  name = :name';
  
          $statement = $MySQLiconn->prepare($sql);
          $statement->bindValue(':name', $name);
  
          $statement->execute();
      //$row = $statement->fetch(PDO::FETCH_ASSOC);
      
       
      $num = $statement->rowCount();
     
   
      return $num;
          
        
       parent::DisConnect( $MySQLiconn);
        
      
      } 	
      


    //location count

    // all locations


    public function getLocations(){
	  
      $instance = parent::getInstance();	
         $MySQLiconn  = $instance->getConnection();
      
          $sql = 'SELECT *
                  FROM   locations
                  ';
  
          $statement = $MySQLiconn->prepare($sql);
          
  
          $statement->execute();
          
		
          return $statement;
      
       parent::DisConnect( $MySQLiconn);
        
      
      } 	


    //all locations

    // find location by id

    public function getLocationById($location_id) {
      $instance = parent::getInstance();	
         $MySQLiconn  = $instance->getConnection();
      
          $sql = 'SELECT *
                  FROM   locations
                  WHERE  location_id = :location_id';
  
          $statement = $MySQLiconn->prepare($sql);
          $statement->bindValue(':location_id', $location_id);
  
          $statement->execute();
          $row = $statement->fetch(PDO::FETCH_ASSOC);
          $this->name = $row['name'];
          $this->area = $row['area'];

          $this->num_shops = $row['num_shops'];

          $this->address = $row['address'];
  
         parent::DisConnect( $MySQLiconn);
  
          return $this->password;
      }

    //find location by id


    // check if shop already added

    public function countShop($shop_number){
	  
      $instance = parent::getInstance();	
         $MySQLiconn  = $instance->getConnection();
      
          $sql = 'SELECT *
                  FROM   shops
                  WHERE  shop_number = :shop_number';
  
          $statement = $MySQLiconn->prepare($sql);
          $statement->bindValue(':shop_number', $shop_number);
  
          $statement->execute();
      //$row = $statement->fetch(PDO::FETCH_ASSOC);
      
       
      $num = $statement->rowCount();
     
   
      return $num;
          
        
       parent::DisConnect( $MySQLiconn);
        
      
      } 	


      //  get shops for editing

      public function getShops(){
	  
        $instance = parent::getInstance();	
           $MySQLiconn  = $instance->getConnection();
        
            $sql = 'SELECT s.shop_id, s.shop_number, s.type, s.features, s.availability_status,s.price, s.size, l.name,s.image,
            l.address from shops s INNER JOIN locations l ON s.location_id = l.location_id ORDER BY s.shop_id DESC
                   
                    ';
    
            $statement = $MySQLiconn->prepare($sql);
            
    
            $statement->execute();
            
      
            return $statement;
        
         parent::DisConnect( $MySQLiconn);
          
        
        } 


        public function addFrontImage($shop_id,$image) {
          $instance = parent::getInstance();	
            $MySQLiconn  = $instance->getConnection();	
          
        try{
        
            $sql = " UPDATE shops set image = :image where shop_id = :shop_id  ";
                             
             $statement = $MySQLiconn->prepare($sql);
      
             $statement->bindValue(':shop_id',$shop_id, PDO::PARAM_STR );
       
             $statement->bindValue(':image',$image, PDO::PARAM_STR );
      
             $statement->execute();
         
         
         parent::DisConnect( $MySQLiconn);
         }
         catch(Exception $e){
          echo "oops! ".$e->getMessage(); 
          
          }   
        }


        // get shop by id


        public function getShopById($shop_id) {
          $instance = parent::getInstance();	
             $MySQLiconn  = $instance->getConnection();
          
              $sql = 'SELECT *
                      FROM   shops
                      WHERE  shop_id = :shop_id';
      
              $statement = $MySQLiconn->prepare($sql);
              $statement->bindValue(':shop_id', $shop_id);
      
              $statement->execute();
              $row = $statement->fetch(PDO::FETCH_ASSOC);
              $this->shop_number = $row['shop_number'];
              $this->location_id = $row['location_id'];
    
              $this->type = $row['type'];
    
              $this->size = $row['size'];

              $this->features = $row['features'];

              $this->image = $row['image'];

              $this->availability_status = $row['availability_status'];
      
             parent::DisConnect( $MySQLiconn);
      
              
          }


        //get shop id


        // get single shop

        public function getShopsByID($shop_id){
	  
          $instance = parent::getInstance();	
             $MySQLiconn  = $instance->getConnection();
          
              $sql = 'SELECT s.shop_id, s.shop_number, s.type, l.location_id, s.features, s.availability_status,s.price, s.size, l.name,s.image,
              l.address, s.lease_duration  from shops s INNER JOIN locations l ON s.location_id = l.location_id where s.shop_id = :shop_id
                     
                      ';
      
              $statement = $MySQLiconn->prepare($sql);
              $statement->bindValue(':shop_id', $shop_id);
              $statement->execute();
              $row = $statement->fetch(PDO::FETCH_ASSOC);

              $this->shop_number = $row['shop_number'];
              $this->location_id = $row['location_id'];
    
              $this->type = $row['type'];
    
              $this->size = $row['size'];

              $this->price = $row['price'];

              $this->features = $row['features'];

              $this->image = $row['image'];

              $this->name = $row['name'];

              $this->lease_duration = $row['lease_duration'];

              $this->availability_status = $row['availability_status'];
      
             parent::DisConnect( $MySQLiconn);
              
        
              
          
           parent::DisConnect( $MySQLiconn);
            
          
          } 


        //get single shop

        //get shop images by ID


        public function getShopImages($shop_id){
	  
          $instance = parent::getInstance();	
             $MySQLiconn  = $instance->getConnection();
          
              $sql = 'SELECT *
                      FROM   shop_images where shop_id  = :shop_id
                      ';
      
              $statement = $MySQLiconn->prepare($sql);
              $statement->bindValue(':shop_id', $shop_id); 
      
              $statement->execute();
              
        
              return $statement;
          
           parent::DisConnect( $MySQLiconn);
            
          
          } 	


        //GET SHOP IMAGES BY ID

        // add customer


        public function addCustomer($name, $email, $contact_information, $business_type, $preferred_size, $preferred_location, $preferred_price_range) {
          $instance = parent::getInstance();	
          $MySQLiconn = $instance->getConnection();	
      
          try {
              $sql = "INSERT INTO customers (name, email, contact_information, business_type, preferred_size, preferred_location, preferred_price_range)
                      VALUES (:name, :email, :contact_information, :business_type, :preferred_size, :preferred_location, :preferred_price_range)";
              
              $statement = $MySQLiconn->prepare($sql);
      
              $statement->bindValue(":name", $name, PDO::PARAM_STR);
              $statement->bindValue(":email", $email, PDO::PARAM_STR);
              $statement->bindValue(":contact_information", $contact_information, PDO::PARAM_STR);
              $statement->bindValue(":business_type", $business_type, PDO::PARAM_STR);
              $statement->bindValue(":preferred_size", $preferred_size, PDO::PARAM_STR);
              $statement->bindValue(":preferred_location", $preferred_location, PDO::PARAM_STR);
              $statement->bindValue(":preferred_price_range", $preferred_price_range, PDO::PARAM_STR);
      
              $statement->execute();
      
              parent::DisConnect($MySQLiconn);
          } catch (PDOException $e) {
              echo "Error: " . $e->getMessage();
          }
      }
      

        //add customer

        // check if customer email aLready exit

        public function countCustomer($email){
	  
          $instance = parent::getInstance();	
             $MySQLiconn  = $instance->getConnection();
          
              $sql = 'SELECT *
                      FROM   customers
                      WHERE  email = :email';
      
              $statement = $MySQLiconn->prepare($sql);
              $statement->bindValue(':email', $email);
      
              $statement->execute();
          //$row = $statement->fetch(PDO::FETCH_ASSOC);
          
           
          $num = $statement->rowCount();
         
       
          return $num;
              
            
           parent::DisConnect( $MySQLiconn);
            
          
          } 	


          // add allocation


          // find customer by email

          public function getCustomerByEmail($email){
	  
            $instance = parent::getInstance();	
               $MySQLiconn  = $instance->getConnection();
            
                $sql = 'SELECT * from customers where email = :email
                       
                        ';
        
                $statement = $MySQLiconn->prepare($sql);
                $statement->bindValue(':email', $email);
                $statement->execute();
                $row = $statement->fetch(PDO::FETCH_ASSOC);
  
                $this->customer_id = $row['customer_id'];
                $this->name = $row['name'];
      
                $this->email = $row['email'];
      
                $this->contact_information = $row['contact_information'];
  
                $this->business_type = $row['business_type'];
  
                $this->preferred_size = $row['preferred_size'];
  
                $this->preferred_location = $row['preferred_location'];
  
                $this->preferred_price_range = $row['preferred_price_range'];
  
               
        
               parent::DisConnect( $MySQLiconn);
                
          
                
            
             parent::DisConnect( $MySQLiconn);
              
            
            } 
  


          // find customer by email


          public function addAllocation($customer_id,$shop_id,$date_applied) {
            $instance = parent::getInstance();	
            $MySQLiconn = $instance->getConnection();	
        
            try {
                $sql = "INSERT INTO allocations (customer_id,shop_id,date_applied)
                        VALUES (:customer_id,:shop_id,:date_applied)";
                
                $statement = $MySQLiconn->prepare($sql);
        
                $statement->bindValue(":customer_id", $customer_id, PDO::PARAM_STR);
                $statement->bindValue(":shop_id", $shop_id, PDO::PARAM_STR);
                $statement->bindValue(":date_applied", $date_applied, PDO::PARAM_STR);
               
                
        
                $statement->execute();
        
                parent::DisConnect($MySQLiconn);
            } catch (PDOException $e) {
                echo "Error: " . $e->getMessage();
            }
        }



        public function getApplications(){
	  
          $instance = parent::getInstance();	
             $MySQLiconn  = $instance->getConnection();
          
              $sql = 'SELECT a.shop_id, a.allocation_id, a.shop_id, a.allocation_date, a.customer_id,a.lease_duration, a.status, a.date_applied,
              c.location_id,c.size,c.price,c.features, c.type, c.shop_number
              from allocations  a INNER JOIN shops c  ON a.shop_id = c.shop_id ORDER BY a.date_applied DESC
                     
                      ';
      
              $statement = $MySQLiconn->prepare($sql);
              
      
              $statement->execute();
              
        
              return $statement;
          
           parent::DisConnect( $MySQLiconn);
            
          
          } 


          // get customer by ID


          public function getCustomerByID($customer_id){
	  
            $instance = parent::getInstance();	
               $MySQLiconn  = $instance->getConnection();
            
                $sql = 'SELECT * from customers where customer_id = :customer_id
                       
                        ';
        
                $statement = $MySQLiconn->prepare($sql);
                $statement->bindValue(':customer_id', $customer_id);
                $statement->execute();
                $row = $statement->fetch(PDO::FETCH_ASSOC);
  
                $this->customer_id = $row['customer_id'];
                $this->customer_name = $row['name'];
      
                $this->email = $row['email'];
      
                $this->contact_information = $row['contact_information'];
  
                $this->business_type = $row['business_type'];
  
                $this->preferred_size = $row['preferred_size'];
  
                $this->preferred_location = $row['preferred_location'];
  
                $this->preferred_price_range = $row['preferred_price_range'];
  
               
        
               parent::DisConnect( $MySQLiconn);
                
          
                
            
             parent::DisConnect( $MySQLiconn);
              
            
            } 


          //get customer by ID


          // get allocation by id

          public function getAllocationByID($allocation_id){
	  
            $instance = parent::getInstance();	
               $MySQLiconn  = $instance->getConnection();
            
                $sql = 'SELECT * from allocations where allocation_id = :allocation_id
                       
                        ';
        
                $statement = $MySQLiconn->prepare($sql);
                $statement->bindValue(':allocation_id', $allocation_id);
                $statement->execute();
                $row = $statement->fetch(PDO::FETCH_ASSOC);
  
                $this->customer_id = $row['customer_id'];
               
                $this->allocation_id = $row['allocation_id'];

                $this->shop_id = $row['shop_id'];
      
                $this->allocation_date = $row['allocation_date'];
      
                $this->status = $row['status'];
  
                $this->lease_duration = $row['lease_duration'];
  
                $this->date_applied = $row['date_applied'];
  
                
  
               
        
               parent::DisConnect( $MySQLiconn);
                
          
                
            
             parent::DisConnect( $MySQLiconn);
              
            
            } 


          //get allocation by id


          //approve allocation


          public function approveAllocation($allocation_id) {
            $instance = parent::getInstance();	
              $MySQLiconn  = $instance->getConnection();	
            
          try{
          
              $sql = " UPDATE allocations set status = 'approved'
                 where allocation_id = :allocation_id   ";
                               
                 
       
             
               $statement = $MySQLiconn->prepare($sql);
      
               $statement->bindValue(':allocation_id',$allocation_id, PDO::PARAM_STR );
       
               $statement->execute();
           
           
           parent::DisConnect( $MySQLiconn);
           }
       
               catch(Exception $e){
             echo "oops! ".$e->getMessage(); 
             
             }   
           }
      


          //approve allocation


    
	
	
}